(*
    ^CX^vύX <> 'Touchin.exe' (Main.pas)
        Copyright (C) 1996,97,2004-11 IGJ-HMC, all rights reserved.
*)

unit Main;

interface

uses
  Windows, SysUtils, Classes, Registry;

type
  EAppError = class(Exception);  // AvP[VG[

type
  // ^CX^v
  TSrcStamp = (tsWrite, tsCreate, tsAccess, tsSame, tsNow);
  TTimeStamp = tsWrite..tsAccess;

  // ύXt
  TModifyTime = (mtNone, mtTime, mtDateDay, mtDateMonth, mtDate, mtUnknown);

  // fBNg̕ύX@
  TTouchDir = (tdNone, tdMatch, tdAll, tdDirOnly);

  // gVXei}CNbΉj
  TSystemTimeEx = record
    wYear: WORD;
    wMonth: WORD;
    wDayOfWeek: WORD;
    wDay: WORD;
    wHour: WORD;
    wMinute: WORD;
    wSecond: WORD;
    dwMicroSeconds: DWORD;
  end;

  // IvVݒ
  TOption = record
    WildName: String;
    SrcStamp: TSrcStamp;
    DestStamps: set of TTimeStamp;
    ModifyTime: TModifyTime;
    TouchDir: TTouchDir;
    SubDir: Boolean;
    Preview: Boolean;
    IgnoreError: Boolean;
    MakeResp: Boolean;
    Expert: Boolean;
    SetTime: TSystemTimeEx;
    DiffTime: Int64;
    SrcFileName: String;
  end;

  // IvVݒQi-z*j
  TOption2 = record
    MicroSecondsDigits: Integer;
//  MicroSecondsLength: Integer;  // vpeBɂD2006ȍ~݂̂Ή
    EnableDelimiter: Boolean;
    RoundTime: Boolean;
  end;

const
  MyRegKeyRoot = {HKEY_CURRENT_USER}'\software\IGJ-HMC';
  DefaultOptionEntry = 'DefaultOption';
  CrLf = #13#10;

var
  Options: array of TOption;
  Option2: TOption2;
  NowFileTime: TFileTime;
  ExeNode, MyRegKey: String;
  DispFirstInfo: Boolean;
  IsWinNT: Boolean;

procedure MainProc;


implementation

uses Sub;

{ g }
procedure Usage;
var
  s: String;
begin
  // ftHgIvV̎擾
  s := 'ݒ';

  with TRegistry.Create do begin
    try
      if OpenKeyReadOnly(MyRegKey) then s := ReadString(DefaultOptionEntry);
    finally
      CloseKey;
      Free;
    end;
  end;

  Writeln(
    CrLf, 'g: Touchin [IvV] <t@C> ...',
    CrLf,
    CrLf, '    -sn            ݓgp       -w       XVύX',
    CrLf, '    -sw[file]      XVgp       -c       쐬ύX',
    CrLf, '    -sc[file]      쐬gp       -a       ANZXύX',
    CrLf, '    -sa[file]      ANZXgp',
    CrLf, '    -ss[file]      X^vgp   -r       TutH_',
    CrLf, '                                        -f0,-f-  tH_Ȃ',
    CrLf, '    -d<date>       t̎w           -f1,-f   }b`tH_̂ݑΏ',
    CrLf, '    -t(+/-)<time>  /ΎԂ̎w  -f2,-f+  ׂẴtH_Ώ',
    CrLf, '                                        -f3      t@CȂ',
    CrLf, '    -x          GLXp[g[h',
    CrLf, '    -i          IvV̏',
    CrLf, '    -v          ύX̃vr[',
    CrLf, '    -g          G[𖳎iut@CȂv̂݁j',
    CrLf, '    -e          ^CX^vpX|Xt@C̍쐬',
    CrLf, '    -zs[digit]  b̌w',
    CrLf, '    -zd[type]   t@C؂蕶@̎w',
    CrLf, '    -zr[type]   FAT/exFAT ɂۂߕ@̎w',
    CrLf, '    -DefOpt     ftHgIvṼWXg',
    CrLf, '                i݂̐ݒF', s, 'j',
    CrLf,
    CrLf, '  EIvṼftHg ''-sn -w -f0'' łB',
    CrLf, '  Et@Cɂ̓ChJ[hgpł܂B' );

  ExitCode := $FF;
  raise EAbort.Create('');
end;


{ IvV擾 }
procedure GetOptions;
const
  InvalidParam: Integer = -1;

var
  Option: TOption;
  OptionsCount: Integer;
  Opt: String;
  Opt1, Opt2, Opt3: Char;
  ErrOpt, DestOpt: Boolean;
  Param: String;
  Params: TStringList;
  DefParamCount: Integer;
  ST: TSystemTimeEx;
  s: String;
  i, iz: Integer;

  // R}h֒ǉ
  procedure AddParam(s: String);
  const
    SingleOption = ['w', 'c', 'a', 'r', 'x', 'i', 'v', 'g', 'e'];
  var
    SL: TStringList;
    Opt: String;
    i, p: Integer;
  begin
    SL := TStringList.Create;
    try
      // Delimiter Ɏw肵ȂĂAXy[XѐR[hi[DEL]ȊOjŕĂ
      SL.DelimitedText := s;

      // p[^ȂPIvV̕
      //  for  SL.Count ŏ]ĂȂ
      i := 0;
      while i < SL.Count do begin
        if (Length(SL[i]) > 2) and (SL[i][1] in ['-', '/']) then begin
          Opt := Copy(SL[i], 2, MaxInt);

          if LowerCase(Opt)[1] in SingleOption then begin
            p := 2;
            if Opt[p] in ['+', '-'] then Inc(p);

            if Length(Opt) >= p then begin
              SL.Insert(i+1, '-' + Copy(Opt, p, MaxInt));
              SL[i] := '-' + Copy(Opt, 1, p-1);
            end;
          end;
        end;

        Inc(i);
      end;

      Params.AddStrings(SL);
    finally
      SL.Free;
    end;
  end;

  // t@CIvV֒ǉ
  procedure AddOption(s: String);
  var
    SL: TStringList;
    Path: String;
    i: Integer;
  begin
    // Xy[X؂蕶Ȃ̂ŁA[DEL]ɂłuĂ
    s := StringReplace(s, ' ', #$7F, [rfReplaceAll]);

    SL := TStringList.Create;
    try
      // ؂蕶FL
      if Option2.EnableDelimiter then begin
        // Z~Rŋ؂ꂽt@CQ̓WJ
        SL.Delimiter := ';';
        SL.DelimitedText := s;
        if SL.Count = 0 then Exit;
      end
      // ؂蕶F
      else begin
        // ̂܂ܒǉ
        SL.Add(s);
      end;

      Path := ExtractFilePath(SL[0]);

      for i := 0 to SL.Count - 1 do begin
        // 擪݂̂̂܂
        if i = 0 then
          Option.WildName := SL[i]
        else
          Option.WildName := Path + SL[i];

        // 󍀖ڂ͖i擪ڂpX܂݁A؂蕶Aw肳Ɣj
        if Length(Option.WildName) = 0 then Continue;

        // u[DEL]߂
        Option.WildName := StringReplace(Option.WildName, #$7F, ' ', [rfReplaceAll]);

        // IzTCYsg
        if Length(Options) <= OptionsCount then SetLength(Options, Length(Options) * 2);

        Options[OptionsCount] := Option;
        Inc(OptionsCount);
      end;

    finally
      SL.Free;
    end;
  end;

  // IvVtO̐ݒ
  procedure SetOptFlg(var Opt: Boolean);
  begin
    case Opt2 of
      '+':  Opt := true;
      '-':  Opt := false;
      #0:   Opt := not Opt;
      else  ErrOpt := true;
    end;
  end;

  // ύX^CX^v̐ݒ
  procedure SetDestStamps(DestStamp: TTimeStamp);
  begin
    // QڂȂ΁AtO]悤Ȏwɂ
    if Opt2 = #0 then begin
      if DestStamp in Option.DestStamps then
        Opt2 := '-'
      else
        Opt2 := '+';
    end;

    case Opt2 of
      '+':  Include(Option.DestStamps, DestStamp);
      '-':  Exclude(Option.DestStamps, DestStamp);
      else  ErrOpt := true;
    end;
  end;

  // IvV̏
  procedure InitializeOption;
  begin
    with Option do begin
      SrcStamp    := tsNow;      // -sn
      DestStamps  := [tsWrite];  // -w
      ModifyTime  := mtNone;     // -d-
      DiffTime    := 0;          // -t+0
      TouchDir    := tdNone;     // -f0
      SubDir      := false;      // -r-
      Preview     := false;      // -v-
      IgnoreError := false;      // -g-
      MakeResp    := false;      // -e-
      Expert      := false;      // -x-
      SrcFileName := '';
    end;

    DestOpt := false;
  end;

  // IvṼp[^ʒu擾
  function OptParamPos(p: Integer): Integer;
  begin
    // Zp[^΁A̎̕
    if Opt[p] in [':', '='] then Inc(p);
    Result := p;
  end;

  // t/p[^o
  //  'hh:mm:ss.us', 'yy-mm-dd' `Aeڂ̐lo
  function GetDateTimeParams(IsTime: Boolean; out Param0, Param1, Param2: WORD; out Param3: DWORD): Integer;
  var
    Num: array[0..3] of DWORD;
    SL: TStringList;
    s: String;
    b: Boolean;
    i: Integer;

  begin
    // p[^̎o
    s := Copy(Opt, OptParamPos(2), MaxInt);

    // <p[^>
    // Ύw̍ŏ̕폜Aw肪Ȃ '0' wƂiwHour 𕉂̒lFInvalidParam ɂłȂ߁AG[ł͂Ȃj
    if IsTime and (Length(s) > 0) and (s[1] in ['+', '-']) then begin
      Delete(s, 1, 1);
      if Length(s) = 0 then s := '0';
    end;

    // ȊOׂ͂ăXy[Xɒu
    b := true;
    for i := 1 to Length(s) do begin
      if s[i] in ['0'..'9'] = false then begin
        s[i] := ' ';
        b := false;
      end;
    end;

    // Zp[^Ȃw̕
    if b then begin
      i := Length(s);

      if IsTime then begin
        if i in [3, 5, 7] then s := s + '0';
        if i >= 3 then Insert(' ', s, 3);
        if i >= 5 then Insert(' ', s, 5 + 1);
        if i >= 7 then Insert(' ', s, 7 + 2);
      end
      else begin
        if i >= 3 then Insert(' ', s, i - 1);
        if i >= 5 then Insert(' ', s, i - 3);
      end;
    end;

    SL := TStringList.Create;
    try
      // Xy[Xŕ
      SL.DelimitedText := s;

      // lϊib͌ '0' tAVɁj
      for i := 0 to SL.Count - 1 do begin
        if i = 3 then begin
          if Length(SL[i]) > 7 then
            SL[i] := IntToStr(InvalidParam)
          else
            SL[i] := SL[i] + StringOfChar('0', 7 - Length(SL[i]));
        end;

        Num[i] := StrToIntDef(SL[i], InvalidParam);
        if i = High(Num) then Break;
      end;

      // ԒlFp[^
      Result := SL.Count;

      // w
      if IsTime then begin
        // ]vȎw肠^܂wȂ
        if (SL.Count > Length(Num)) or (SL.Count = 0) then begin
          Param0 := InvalidParam;
          Result := 1;
        end
        else begin
          // ŵȂڂ́A[
          for i := SL.Count to High(Num) do Num[i] := 0;

          Param0 := Num[0];
          Param1 := Num[1];
          Param2 := Num[2];
          Param3 := Num[3];
        end;
      end
      // tw
      else begin
        case SL.Count of
          //uv̂
          1: begin
            Param2 := Num[0];
          end;

          //u-v̂
          2: begin
            Param1 := Num[0];
            Param2 := Num[1];
          end;

          //uN--v
          3: begin
            Param0 := Num[0];
            Param1 := Num[1];
            Param2 := Num[2];
          end;

          // ]vȎw肠^܂wȂ
          else begin
            Param0 := InvalidParam;
            Result := 1;
          end;
        end;
      end;

    finally
      SL.Free;
    end;
  end;

  // tp
  function GetDateParams(var SystemTimeEx: TSystemTimeEx): Integer;
  var DmyDWORD: DWORD;
  begin
    with SystemTimeEx do Result := GetDateTimeParams(false, wYear, wMonth, wDay, DmyDWORD);
  end;

  // p
  function GetTimeParams(var SystemTimeEx: TSystemTimeEx): Integer;
  begin
    with SystemTimeEx do Result := GetDateTimeParams(true, wHour, wMinute, wSecond, dwMicroSeconds);
  end;

begin
  if ParamCount = 0 then Usage;

  // ftHgIvṼWXg
  if (ParamStr(1)[1] in ['-', '/']) and (AnsiLowerCase(Copy(ParamStr(1), 2, MaxInt)) = 'defopt') then begin
    // IvV쐬
    Param := '';
    for i := 2 to ParamCount do Param := Param + ParamStr(i) + ' ';
    Delete(Param, Length(Param), 1);

    with TRegistry.Create do begin
      try
        // IvV񂪂Ώ
        if Param <> '' then begin
          if OpenKey(MyRegKey, true) then begin
            try
              WriteString(DefaultOptionEntry, Param);
            finally
              CloseKey;
            end;

            Writeln(CrLf, 'ftHgIvVWXgɏ݂܂B');
          end
          else begin
            raise EAppError.Create('ftHgIvVWXgɏ߂܂');
          end;
        end
        // Ȃ΍폜
        else begin
          if not DeleteKey(MyRegKey) then
            raise EAppError.Create('ftHgIvVWXgɐݒ肳Ă܂');

          // ʃL[ȂA폜
          if OpenKeyReadOnly(MyRegKeyRoot) then begin
            try
              if not HasSubKeys then DeleteKey(MyRegKeyRoot);
            finally
              CloseKey;
            end;
          end
          else begin
            raise EAppError.Create('ftHgIvV̏ʃL[WXg폜ł܂');
          end;

          Writeln(CrLf, 'ftHgIvVWXg폜܂B');
        end;

      finally
        Free;
      end;
    end;

    // ̂܂܏I
    Exit;
  end;

  // ftHgIvV̎擾iWXgorϐj
  with TRegistry.Create do begin
    try
      // WXgڂɊJ΁iYL[݂΁jAWXg
      if OpenKeyReadOnly(MyRegKey) then
        s := ReadString(DefaultOptionEntry)
      // łȂ΁Aϐ
      else
        s := GetEnvironmentVariable(ExeNode);

    finally
      CloseKey;
      Free;
    end;
  end;

  Params := TStringList.Create;
  try
    AddParam(s);
    DefParamCount := Params.Count;

    // R}hC̎o
    for i := 1 to ParamCount do begin
      // X|Xt@Cw
      if ParamStr(i)[1] = '@' then begin
        s := Copy(ParamStr(i), 2, MaxInt);

        with TStringList.Create do begin
          try
            try
              LoadFromFile(s);
            except
              raise EAppError.Create('X|Xt@C (' + s + ') J܂');
            end;

            AddParam(Text);
          finally
            Free;
          end;
        end;
      end
      // ʏ̈
      else begin
        // Xy[X̕h߂Ɋ
        AddParam('"' + ParamStr(i) + '"');
      end;
    end;

(* for Debug
    for i := 0 to Params.Count - 1 do Writeln(Format('Params[%d]=%s', [i, Params[i]]));
*)

    // IvVݒ菉
    InitializeOption;
    ErrOpt := false;
    OptionsCount := 0;
    SetLength(Options, 256);

    // ẻ
    for i := 0 to Params.Count - 1 do begin
      Param := Params[i];

      // t@C
      if Param[1] in ['-', '/'] = false then begin
        // ftHgIvVɃt@Cw肳Ă΁AG[
        if i < DefParamCount then begin
          ErrOpt := true;
        end
        else begin
          AddOption(Param);
        end;
      end
      // IvV
      else begin
        // PȂ΁i'-'or'/' Ȃ΁jA݂ȂIvVɂăG[ɂ
        if Length(Param) = 1 then begin
          Opt1 := '-';
          Opt2 := #0;
          Opt3 := #0;
        end
        else begin
          Opt  := Copy(Param, 2, MaxInt);
          s    := LowerCase(Opt);
          Opt1 := s[1];
          Opt2 := s[2];
          Opt3 := s[OptParamPos(2)];
        end;

        // \[Xw (-s*)
        if Opt1 = 's' then begin
          // ݓ
          if Opt2 = 'n' then begin
            Option.SrcStamp := tsNow;
          end
          else begin
            // t@Co
            Option.SrcFileName := Copy(Opt, OptParamPos(3), MaxInt);

            case Opt2 of
              'w':  Option.SrcStamp := tsWrite;
              'c':  Option.SrcStamp := tsCreate;
              'a':  Option.SrcStamp := tsAccess;
              's':  Option.SrcStamp := tsSame;
              else  ErrOpt := true;
            end;
          end;
        end

        // t (-d:*)
        else if Opt1 = 'd' then begin
          case Opt3 of
            'u':  Option.ModifyTime := mtUnknown;
            '-':  Option.ModifyTime := mtNone;

            else begin
              // w肪Ȃ΁A[ŏ
              if Option.ModifyTime = mtNone then begin
                with Option.SetTime do begin
                  wHour := 0;  wMinute := 0;  wSecond := 0;  dwMicroSeconds := 0;
                end;
              end;

              case GetDateParams(Option.SetTime) of
                1:   Option.ModifyTime := mtDateDay;
                2:   Option.ModifyTime := mtDateMonth;
                else Option.ModifyTime := mtDate;
              end;
            end;
          end;
        end

        //  (-t:*)
        else if Opt1 = 't' then begin
          case Opt3 of
            // Ύw
            '+', '-': begin
              GetTimeParams(ST);
              SystemTimeExToDiffTime(ST, Option.DiffTime);
              if Opt3 = '-' then Option.DiffTime := -Option.DiffTime;
            end;

            else begin
              GetTimeParams(Option.SetTime);
              if Option.ModifyTime = mtNone then Option.ModifyTime := mtTime;
            end;
          end;
        end

        // fBNgύX@ (-f*)
        else if Opt1 = 'f' then begin
          case Opt2 of
            '0','-':  Option.TouchDir := tdNone;
            '1',#0 :  Option.TouchDir := tdMatch;
            '2','+':  Option.TouchDir := tdAll;
            '3'    :  Option.TouchDir := tdDirOnly;
            else      ErrOpt := true;
          end;
        end

        // TufBNg (-r)
        else if Opt1 = 'r' then begin
          SetOptFlg(Option.SubDir);
        end

        // vr[ (-v)
        else if Opt1 = 'v' then begin
          SetOptFlg(Option.Preview);
        end

        // G[𖳎 (-g)
        else if Opt1 = 'g' then begin
          SetOptFlg(Option.IgnoreError);
        end

        // ^CX^vpX|Xt@C (-e)
        else if Opt1 = 'e' then begin
          SetOptFlg(Option.MakeResp);
        end

        // GLXp[g[h (-x)
        else if Opt1 = 'x' then begin
          SetOptFlg(Option.Expert);
        end

        // ݒ (-z*)
        else if Opt1 = 'z' then begin
          s := Copy(Opt, OptParamPos(3), MaxInt);

          case Opt2 of
            // b̎w (-zs)
            's': begin
              if Length(s) = 0 then begin
                iz := 6;
              end
              else begin
                iz := StrToIntDef(s, -1);
                if (iz < 0) or (iz > 7) then ErrOpt := true;
              end;

              Option2.MicroSecondsDigits := iz;
            end;

            // t@C؂蕶@̎w (-zd)
            'd': begin
              if Length(s) = 0 then begin
                iz := 1;
              end
              else begin
                iz := StrToIntDef(s, -1);
                if (iz < 0) or (iz > 2) then ErrOpt := true;
              end;

              Option2.EnableDelimiter := LongBool(iz);
            end;

            // FAT/exFAT ɂۂߕ@̎w (-zr)
            'r': begin
              if Length(s) = 0 then begin
                iz := 1;
              end
              else begin
                iz := StrToIntDef(s, -1);
                if (iz < 0) or (iz > 2) then ErrOpt := true;
              end;

              Option2.RoundTime := LongBool(iz);
            end

            else ErrOpt := true;
          end;
        end

        // ύXw (-w/c/a)CIvV (-i)Cg
        else begin
          if not DestOpt then Option.DestStamps := [];  // ܂w肪Ȃ΁ANA
          DestOpt := true;

          case Opt1 of
            'w':  SetDestStamps(tsWrite);
            'c':  SetDestStamps(tsCreate);
            'a':  SetDestStamps(tsAccess);
            'i':  InitializeOption;
            '?':  Usage;
            else  ErrOpt := true;
          end;
        end;
      end;

      // sv
      Params[i] := '';

      if ErrOpt then
        raise EAppError.Create('IvVɌ肪܂');
    end;

  finally
    Params.Free;
  end;

  SetLength(Options, OptionsCount);
  if Length(Options) = 0 then
    raise EAppError.Create('t@Cw肵Ă');

  // IvV̐
  for i := Low(Options) to High(Options) do begin
    // GLXp[g[hłȂ΁AŏIݒԂRs[it@C͂̂܂܁j
    if not Options[i].Expert then begin
      Option.WildName := Options[i].WildName;
      Options[i] := Option;
    end;

    if Options[i].DestStamps = [] then
      raise EAppError.Create('^CX^vύX̎w肪܂');

    // QNSɕϊ
    with Options[i].SetTime do begin
      if      wYear < 80  then Inc(wYear, 2000)
      else if wYear < 100 then Inc(wYear, 1900);
    end;
  end;
end;


{ C }
procedure MainProc;
var
  i: Integer;

begin
  // ϐ
  IsWinNT := (Win32Platform = VER_PLATFORM_WIN32_NT);

  // WinNT nȂsUTCϊAWin9x nȂ萔̂܂܎gp
  if IsWinNT then
    LocalFileTimeToFileTime(UnknownFileTimeNT, UnknownFileTime)
  else
    UnknownFileTime := UnknownFileTime9x;

  // IvV -z* ̏
  with Option2 do begin
    MicroSecondsDigits := 6;      // -zs6
//  MicroSecondsLength := 6 + 1;  // -zs6
    EnableDelimiter := true;      // -zd1
    RoundTime := true;            // -zr1
  end;

  // EXEt@C̃m[hAWXgL[orϐƂ
  ExeNode := ExtractFileName(ParamStr(0));
  ExeNode := Copy(ExeNode, 1, Length(ExeNode) - Length(ExtractFileExt(ExeNode)));

  // WXgL[쐬
  MyRegKey := MyRegKeyRoot + '\' + ExeNode;

  try
    Writeln(ErrOutput,
      '^CX^vύX <>  version 1.27 (for Win32 console)', CrLf,
      'Copyright (C) 1996-2011 IGJ-HMC, all rights reserved.');

    GetSystemTimeAsFileTime(NowFileTime);
    GetOptions;

    for i := Low(Options) to High(Options) do begin
      if not SetTimeStampProc(Options[i].WildName, Options[i]) then begin
        if Options[i].IgnoreError then
          Writeln(CrLf, 'Warn.: t@C (', Options[i].WildName, ') ܂B')
        else
          raise EAppError.Create('t@C (' + Options[i].WildName + ') ܂');
      end;
    end;

  except
    // AvG[ȂAG[\EIR[hZbg
    on E: EAppError do begin
      Writeln(ErrOutput, CrLf, 'Error: ', E.Message, 'B');
      ExitCode := 1;
    end;

    // TCgO
    on E: EAbort do { Nop };
  end;
end;

end.

